// Copyright 2013--2014 David Eisenstat
// Released under http://opensource.org/licenses/MIT
// mississippi April 2014 version

#include "common.h"

int orientation_less(struct Line l, struct Line m) {
  if (l.q.y < l.p.y) {
    if (m.q.y >= m.p.y) {
      return 1;
    } else if (l.q.x <= l.p.x) {
      if (m.q.x > m.p.x) {
        return 1;
      }
    } else if (m.q.x <= m.p.x) {
      return 0;
    }
  } else if (m.q.y < m.p.y) {
    return 0;
  } else if (l.q.x >= l.p.x) {
    if (m.q.x < m.p.x) {
      return 1;
    } else if (m.q.y == m.p.y) {
      return 0;
    } else if (l.q.y == l.p.y) {
      return 1;
    }
  } else if (m.q.x >= m.p.x || l.q.y == l.p.y) {
    return 0;
  } else if (m.q.y == m.p.y) {
    return 1;
  }
  unsigned long long a = (unsigned long long)l.q.x - (unsigned long long)l.p.x;
  unsigned long long b = (unsigned long long)l.q.y - (unsigned long long)l.p.y;
  unsigned long long c = (unsigned long long)m.q.x - (unsigned long long)m.p.x;
  unsigned long long d = (unsigned long long)m.q.y - (unsigned long long)m.p.y;
  return a * d > b * c;
}
